%% This file includes all the different parameters used in the cases of the thesis

omega_turbo_0 = .9*[1;1;1];
AFLR = 1;
mpcOn = 1;
useUMaxNow=0;
t0 = .01;
T = [0 50];
Qload = 0;
QloadStepTime = 0;
QloadStep = 0;
mpcValSaveTime = 19;
loadSlope = 0;
loadRampStart = 0;
LoadRampStop = 0;
loadBias = 0;
u0 = 1*[1; 1; 1];
switch casenr
    case 0
        % Disconnect w/o FLR load 20%
        AFLR = 0;
        disconnectGenset3Time = 19.99;
        loadAmplitude = 0*Sb_bus*0.35;
        loadfreq = 2*pi*0;
        loadStart = .2*Sb_bus;
        T = [0 3];
    case 1
        % Disconnect w/o FLR load 20%
        AFLR = 0;
        disconnectGenset3Time = 19.99;
        loadAmplitude = 0*Sb_bus*0.35;
        loadfreq = 2*pi*0;
        loadStart = .35*Sb_bus;
        u0 =.2*[1; 1; 1];
        wNLstart = 1.01*[1;1;1];
    case 2
        % Disconnect w/o FLR load 20% w/dyncons
        AFLR = 0;
        disconnectGenset3Time = 19.99;
        loadAmplitude = 0*Sb_bus*0.35;
        loadfreq = 2*pi*0;
        loadStart = .35*Sb_bus;
        useUMaxNow=1;
        u0 = .2*[1; 1; 1];
        wNLstart = 1.01*[1;1;1];
    case 3
        % Disconnect w FLR load 80%
        disconnectGenset3Time = 19.99;
        loadAmplitude = 0*Sb_bus*0.35;
        loadfreq = 2*pi*0;
        loadStart = .8*Sb_bus;
    case 4
        % Not disconnect w/o FLR load 20%
        AFLR = 0;
        disconnectGenset3Time = 10000;
        loadAmplitude = 0*Sb_bus*0.35;
        loadfreq = 2*pi*0;
        loadStart = .2*Sb_bus;
    case 5
        % Disconnect w/ FLR load 40%
        disconnectGenset3Time = 19.99;
        loadAmplitude = 0*Sb_bus*0.35;
        loadfreq = 2*pi*0;
        loadStart = .6*Sb_bus;
    case 6
        % Disconnect w/FLR&uMax load 80%
        disconnectGenset3Time = 19.99;
        loadAmplitude = 0*Sb_bus*0.35;
        loadfreq = 2*pi*0;
        loadStart = .8*Sb_bus;
        useUMaxNow=1;
        mpcValSaveTime = 19;
    case 7
        % Load freq .01
        disconnectGenset3Time = 10000.00;
        loadAmplitude = Sb_bus*0.35;
        loadfreq = 2*pi*0.01;
        loadStart = .4*Sb_bus;
        T = [0 200];
        mpcValSaveTime = 100;
    case 8
        u0 = 0*[1; 1; 1];
        % Load freq .1
        disconnectGenset3Time = 10000.00;
        loadAmplitude = Sb_bus*0.35;
        loadfreq = 2*pi*0.1;
        loadStart = .4*Sb_bus;
    case 9
        % Load freq .1 new udMAX
        disconnectGenset3Time = 10000.00;
        loadAmplitude = Sb_bus*0.35;
        loadfreq = 2*pi*0.1;
        loadStart = .4*Sb_bus;
        udMaxMPC = .3*[1;1;1]*samplingsTime;
    case 10
        % Load freq .1 use uMAX
        disconnectGenset3Time = 10000.00;
        loadAmplitude = Sb_bus*0.35;
        loadfreq = 2*pi*0.1;
        loadStart = .4*Sb_bus;
        useUMaxNow=1;
    case 11
        % Load freq .1 no MPC
        disconnectGenset3Time = 10000.00;
        loadAmplitude = Sb_bus*0.35;
        loadfreq = 2*pi*0.1;
        loadStart = .4*Sb_bus;
        mpcOn=0;
    case 12
        % No frequency cost
        u0 = .6*[1; 1; 1];
        AFLR = 1;
        useUMaxNow=1;
        disconnectGenset3Time = 49.99;
        T = [0 80];
        mpcValSaveTime = 49;
        loadAmplitude = 0*Sb_bus*0.35;
        loadfreq = 2*pi*0;
        loadStart = .8*Sb_bus;
        ud = 1.03*[1.1;.9;1];
        %        omega, u1, u2, u3, slack variable for frequency error
        Qn = diag([0 .01 .01 .01 100]);
        
    case 13
        % High frequency cost
        u0 = .6*[1; 1; 1];
        AFLR = 1;
        useUMaxNow=1;
        disconnectGenset3Time = 19.99;
        loadAmplitude = 0*Sb_bus*0.35;
        loadfreq = 2*pi*0;
        loadStart = .8*Sb_bus;
        ud = 1.03*[1.1;.9;1];
        %        omega, u1, u2, u3, slack variable for frequency error
        Qn = diag([10 .01 .01 .01 100]);
    case 14
        % Ramp time tuning
        omega_turbo_0 = 0*[1;1;1];
        u0 = 0*[1; 1; 1];
        AFLR = 1;
        disconnectGenset3Time = 10000;
        loadAmplitude = 0*Sb_bus*0.35;
        loadfreq = 2*pi*0;
        loadStart = 0.01*Sb_bus;
        loadSlope = Sb_bus/30;
        loadRampStart = 10;
        LoadRampStop = Sb_bus;
        T = [0 45];
        %        omega, u1, u2, u3, slack variable for frequency error
        mpcOn = 1;
    case 15
        % Disconnect w/o FLR load 20%, increased update frequency
        AFLR = 0;
        udMaxMPC = udMaxMPC*samplingsTime/.3;
        samplingsTime = .3;
        disconnectGenset3Time = 19.99;
        loadAmplitude = 0*Sb_bus*0.35;
        loadfreq = 2*pi*0;
        loadStart = .2*Sb_bus;
    case 16
        % Disconnect w/o FLR load 20%, increased update frequency
        AFLR = 0;
        udMaxMPC = udMaxMPC*samplingsTime/.5;
        samplingsTime = .5;
        disconnectGenset3Time = 19.99;
        loadAmplitude = 0*Sb_bus*0.35;
        loadfreq = 2*pi*0;
        loadStart = .2*Sb_bus;

    case 17
        % Disconnect w FLR load 20%
        AFLR = 0;
        mpcOn = 0;
        disconnectGenset3Time = 19.99;
        loadAmplitude = 0*Sb_bus*0.35;
        loadfreq = 2*pi*0;
        loadStart = .2*Sb_bus;   
	case 18
        % Disconnect w/o FLR load 20% for check of u_desired
        T = [0 20];
        AFLR = 0;
        %ud = 1.1*[1.1;.9;1];
        mpcOn = 1;
        disconnectGenset3Time = 1000.00;
        loadAmplitude = 0*Sb_bus*0.35;
        loadfreq = 2*pi*0;
        loadStart = .2*Sb_bus;   
        %        omega, u1, u2, u3, slack variable for frequency error
        Qn = diag([1 .01 .01 .02 100]);
        %% Cost function worst case
        %             omega, u1, u2, slack variable for frequency error
        Qw = diag([0 .00 .00 0]);
        % Cost of changing no load frequency
        Rw = 0*diag([1 1]);
	case 19
        T = [0 20];
        % Disconnect w/o FLR load 20% for check of u_desired
        AFLR = 0;
        mpcOn = 1;
        disconnectGenset3Time = 0.00;
        loadAmplitude = 0*Sb_bus*0.35;
        loadfreq = 2*pi*0;
        loadStart = .2*Sb_bus;   
        %        omega, u1, u2, u3, slack variable for frequency error
        Qn = diag([1 .01 .01 .01 100]);
        %% Cost function worst case
        %             omega, u1, u2, slack variable for frequency error
        Qw = diag([1 .01 .01 0]);
        u0 = [.4 .4 .4];
        
    case 20
        % Ramp time tuning
        omega_turbo_0 = 0*[1;1;1];
        u0 = 0*[1; 1; 1];
        AFLR = 1;
        disconnectGenset3Time = 10000;
        loadAmplitude = 0*Sb_bus*0.35;
        loadfreq = 2*pi*0;
        loadStart = 0.01*Sb_bus;
        loadSlope = Sb_bus/30;
        loadRampStart = 10;
        LoadRampStop = Sb_bus;
        T = [0 45];
        %        omega, u1, u2, u3, slack variable for frequency error
        mpcOn = 1;
        useUMaxNow=1;
    case 21
        % Disconnect w/o FLR load 20%, increased update frequency
        T = [0 6];
        AFLR = 0;
        udMaxMPC = udMaxMPC*samplingsTime/1;
        samplingsTime = 1;
        disconnectGenset3Time = 19.99;
        loadAmplitude = 0*Sb_bus*0.35;
        loadfreq = 2*pi*0;
        loadStart = .2*Sb_bus;
    case 22
        % Ramp time tuning
        omega_turbo_0 = 0*[1;1;1];
        u0 = 0*[1; 1; 1];
        AFLR = 1;
        disconnectGenset3Time = 10000;
        loadAmplitude = 0*Sb_bus*0.35;
        loadStep = 0.2*Sb_bus;
        loadfreq = 2*pi*0;
        loadStart = 0.01*Sb_bus;
        loadSlope = Sb_bus/30;
        loadRampStart = 10;
        loadStepTime = loadRampStart;
        LoadRampStop = Sb_bus-loadStep;
        T = [0 45];
        useUMaxNow=1;
        %        omega, u1, u2, u3, slack variable for frequency error
        mpcOn = 1;
    case 23
        % Disconnect w/o FLR load 35% w/o mpc
        AFLR = 0;
        disconnectGenset3Time = 19.99;
        loadAmplitude = 0*Sb_bus*0.35;
        loadfreq = 2*pi*0;
        loadStart = .35*Sb_bus;
        useUMaxNow=0;
        u0 = .2*[1; 1; 1];
        wNLstart = 1.01*[1;1;1];
        mpcOn = 0;
    case 24
        % Disconnect w/FLR&uMax load 80%
        disconnectGenset3Time = 19.99;
        loadAmplitude = 0*Sb_bus*0.35;
        loadfreq = 2*pi*0;
        loadStart = .8*Sb_bus;
        useUMaxNow=1;
        mpcValSaveTime = 19;
        mpcOn = 0;
        
    case 25
        % Disconnect w/FLR&uMax load 80%
        disconnectGenset3Time = 20.01;
        loadAmplitude = 0*Sb_bus*0.35;
        loadfreq = 2*pi*0;
        loadStart = .8*Sb_bus;
        useUMaxNow=1;
        mpcValSaveTime = 19;
        
    case 26
        % Disconnect w/o FLR load 20% w/dyncons
        AFLR = 0;
        disconnectGenset3Time = 20.01;
        loadAmplitude = 0*Sb_bus*0.35;
        loadfreq = 2*pi*0;
        loadStart = .35*Sb_bus;
        useUMaxNow=1;
        u0 = .2*[1; 1; 1];
        wNLstart = 1.01*[1;1;1];
    case 27
        % Load freq .01
        disconnectGenset3Time = 10000.00;
        loadAmplitude = Sb_bus*0.35;
        loadfreq = 2*pi*0.01;
        loadStart = .4*Sb_bus;
        T = [0 200];
        mpcValSaveTime = 100;
        mpcOn = 0;
    case {117,118}
        % Set control horizon to 5,15
        % Disconnect w/o FLR load 20%, increased update frequency
        AFLR = 0;
        Samplingtime 
        disconnectGenset3Time = 19.99;
        loadAmplitude = 0*Sb_bus*0.35;
        loadfreq = 2*pi*0;
        loadStart = .2*Sb_bus;
end
filename = sprintf('case%d',casenr);
mpcValFileName = casenr;
aFLR = AFLR;
if (casenr~=22)  
    pFLR =  aFLR*loadStart/2/Sb_bus;
    loadStep = loadStart-Sb_bus*pFLR;
    loadStepTime=disconnectGenset3Time+tFLR;
else
    pFLR =  AFLR/2;
end
hasFilename = 1;

