%% Makes a file for debugging showing active constraints and predictions

function debuggConstraints(Omega,omega_L,omega_U,dw,m,psi,phi,time,genset3connected,debuggingfile)
coder.extrinsic('fprintf');
%% Calculate active constraints
tL=(Omega*dw-omega_L)<0.00001;
tU=(-Omega*dw+omega_U)<0.00001;
%% Calculate control output
z = phi + psi*dw;

%% Prints to file
fprintf(debuggingfile,'\nTime: %.2f',time);
if(genset3connected)
    % i=0
    fprintf(debuggingfile,'\nk \tu1\tu2 \tu3 \tdu1\tdu2\tdu3\twL \twU \tw \t\te \t\t\tu1 \t\tu2 \t\tu3 \t\tdwNL1 \t dwNL2 \tdwNL3 \tu1 \tu2 \tdu1\tdu2\twL \twU\tw \t\te \t\t\tu1 \t\tu2 \t\tdwNL1 \t dwNL2');
    fprintf(debuggingfile,'\n0');
    fprintf(debuggingfile,'\t\t\t\t\t\t\t\t');
    fprintf(debuggingfile,'\t%.4f\t',z(1));
    fprintf(debuggingfile,'\t\t');
    for k=2:4
        fprintf(debuggingfile,'\t%.4f',z(k));
    end
    for k=1:3
        fprintf(debuggingfile,'\t%.4f',dw(k));
    end

    % i=1
    fprintf(debuggingfile,'\n1');
    for k=1:8
        fprintf(debuggingfile,'\t%d%d',tL(k),tU(k));
    end
    fprintf(debuggingfile,'\t%.4f',z(5+1));
    fprintf(debuggingfile,'\t%.2e',dw(4));
    for k=2:4
        fprintf(debuggingfile,'\t%.4f',z(5+k));
    end
    for k=1:3
        fprintf(debuggingfile,'\t%.4f',dw(4+k));
    end
    fprintf(debuggingfile,'\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t');
    for k=1:2
        fprintf(debuggingfile,'\t%.4f',dw(m*4+k));
    end
    % i>=2
    for l = 1:(m-2)
        % Nominal case
        fprintf(debuggingfile,'\n%d',l+1);
        for k=1:8
            fprintf(debuggingfile,'\t%d%d',tL(l*9+k),tU(l*9+k));
        end
        fprintf(debuggingfile,'\t%.4f',z((l+1)*5+1));
        fprintf(debuggingfile,'\t%.2e',dw(l*4+4));
        for k=2:4
            fprintf(debuggingfile,'\t%.4f',z((l+1)*5+k));
        end
        for k=1:3
            fprintf(debuggingfile,'\t%.4f',dw((l+1)*4+k));
        end
        % Worst case
        for k=1:6
            fprintf(debuggingfile,'\t%d%d',tL((m)*9+(l-1)*7+k),tU((m)*9+(l-1)*7+k));
        end
        fprintf(debuggingfile,'\t%.4f',z((m+1)*5+(l-1)*4+1));
        fprintf(debuggingfile,'\t%.2e',dw(m*4+(l-1)*3+3));
        for k=2:3
            fprintf(debuggingfile,'\t%.4f',z((m+1)*5+(l-1)*4+k));
        end
        for k=1:2
            fprintf(debuggingfile,'\t%.4f',dw(m*4+(l)*3+k));
        end
    end
        % k=m
    l = m-1;
    % Nominal case
    fprintf(debuggingfile,'\n%d',l+1);
    for k=1:8
        fprintf(debuggingfile,'\t%d%d',tL((l-1)*9+k),tU((l-1)*9+k));
    end
    fprintf(debuggingfile,'\t%.4f',z((l+1)*5+1));
    fprintf(debuggingfile,'\t%.2e',dw((l-1)*4+4));
    for k=2:4
        fprintf(debuggingfile,'\t%.4f',z((l+1)*5+k));
    end
    fprintf(debuggingfile,'\t\t\t\t\t\t');
    % Worst case
    for k=1:6
        fprintf(debuggingfile,'\t%d%d',tL((m)*9+(l-1)*7+k),tU((m)*9+(l-1)*7+k));
    end
    fprintf(debuggingfile,'\t%.4f',z((m+1)*5+(l-1)*4+1));
    fprintf(debuggingfile,'\t%.2e',dw(m*4+(l-1)*3+3));
    for k=2:3
        fprintf(debuggingfile,'\t%.4f',z((m+1)*5+(l-1)*4+k));
    end
else
    % i=0
    fprintf(debuggingfile,'\nk \tu1\tu2 \tdu1\tdu2\twL \twU \tw \t\te \t\t\tu1 \t\tu2 \t\tdwNL1 \tdwNL2');
    fprintf(debuggingfile,'\n0');
    fprintf(debuggingfile,'\t\t\t\t\t\t');
    fprintf(debuggingfile,'\t%.4f\t',z(1));
    fprintf(debuggingfile,'\t\t');
    for k=2:3
        fprintf(debuggingfile,'\t%.4f',z(k));
    end
    for k=1:2
        fprintf(debuggingfile,'\t%.4f',dw(k));
    end

    % i=1
    fprintf(debuggingfile,'\n1');
    for k=1:6
        fprintf(debuggingfile,'\t%d%d',tL(k),tU(k));
    end
    fprintf(debuggingfile,'\t%.4f',z(4+1));
    fprintf(debuggingfile,'\t%.2e',dw(3));
    for k=2:3
        fprintf(debuggingfile,'\t%.4f',z(4+k));
    end
    for k=1:2
        fprintf(debuggingfile,'\t%.4f',dw(3+k));
    end
    
    % i>=2
    for l = 1:(m-2)
        % Nominal case
        fprintf(debuggingfile,'\n%d',l+1);
        for k=1:6
            fprintf(debuggingfile,'\t%d%d',tL(l*7+k),tU(l*7+k));
        end
        fprintf(debuggingfile,'\t%.4f',z((l+1)*4+1));
        fprintf(debuggingfile,'\t%.2e',dw(l*3+3));
        for k=2:3
            fprintf(debuggingfile,'\t%.4f',z((l+1)*4+k));
        end
        for k=1:2
            fprintf(debuggingfile,'\t%.4f',dw((l+1)*3+k));
        end
    end
        % k=m
    l = m-1;
    % Nominal case
    fprintf(debuggingfile,'\n%d',l+1);
    for k=1:6
        fprintf(debuggingfile,'\t%d%d',tL((l-1)*7+k),tU((l-1)*7+k));
    end
    fprintf(debuggingfile,'\t%.4f',z((l+1)*4+1));
    fprintf(debuggingfile,'\t%.2e',dw((l-1)*3+3));
    for k=2:3
        fprintf(debuggingfile,'\t%.4f',z((l+1)*4+k));
    end
    fprintf(debuggingfile,'\t\t\t\t\t\t');
    
end
end
