%% Calculates the psi, phi, and T matrix as given in the Thesis.
function [psi phi T] = findPsiT(m,n,Nz,Nopt,Nx,Ad,Bd,B0d,C,D,z0,zd)
%% Make a matrix with:
% 0
% C
% C+Ca
% ...
temp = zeros((m+1)*Nz,Nx);
temp((Nz+1):Nz*2,:) = C;
for i =Nz*2+1:Nz:(m+1)*Nz
    temp(i:(i+Nz-1),:) = C+temp(i+(-Nz:-1),:)*Ad;
end
%% make the phi vector:
phi = temp*B0d;
% Add initial values
for i = 1:Nz:Nz*(m+1)
    phi(i+(0:Nz-1)) = phi(i+(0:Nz-1)) + z0;
end

%% Make the tracking error vector:
T = zeros(Nz*(m+1),1);
for k = 1:Nz:Nz*(m+1)
    T(k+(0:(Nz-1)),1) = zd-phi(k+(0:(Nz-1)),1);
end

%% Make the psi matrix
psi = zeros(Nz*(m+1),(m)*(n+1));
psi(:,1:n) = temp*Bd;
% Add D
for k = Nz+1:Nz:Nz*(m+1)
    psi(k:(k+Nz-1),1:Nopt) = D +psi(k+(0:(Nz-1)),1:Nopt);
end

% Copy horizontally
for k = 2:m
    psi((k-1)*Nz+1:end,(k-1)*Nopt+(1:Nopt)) = psi(1:(end-(k-1)*Nz),1:Nopt);
end

% Add slack variables:
psi(2*Nz:Nz:end,Nopt:Nopt:end) = eye(m);
end

