%% Calculates the psi, phi, and T matrix as given in the Thesis for simulation of failure case.
function [psi phi T] = findPsiTWorstCase(m,n,Nz,Nopt,Nx,Bd,B0d,Adw,Bdw,B0dw,Cw,Dw,AFLRpd,dp,z0w,zdw)
Cn2w = zeros(Nx,Nx+4);
Cn2w(1:Nx,1:Nx) = eye(Nx);
%% Make three matrix with:
% temp      temp2   temp3
% C         C       CA
% C+CA      CA      CA^2
% ...       ...     ...
temp = zeros((m-1)*Nz,Nx);
temp(1:Nz,:) = Cw;
temp2 = temp;
for i =Nz+(1:Nz:(m-2)*Nz)
    temp(i:(i+Nz-1),:) = Cw+temp(i+(-Nz:-1),:)*Adw;
    temp2(i:(i+Nz-1),:) = temp2(i+(-Nz:-1),:)*Adw;
end
temp3 = [temp2((Nz+1):end,:);temp2((end-Nz+1):end,:)*Adw];
%% make the phi vector:
pFLR = [dp; zeros(Nx-1,1)];
phi = temp*B0dw+temp3*Cn2w*B0d+temp2*(Adw-AFLRpd)*pFLR;
% Add initial values
for i = 1:Nz:Nz*(m-1)
    phi(i+(0:n+1)) = phi(i+(0:n+1)) + z0w;
end

%% Make the tracking error vector:
T = zeros(Nz*(m-1),1);
for k = 1:Nz:Nz*(m-1)
    T(k+(0:(Nz-1)),1) = zdw-phi(k+(0:(Nz-1)),1);
end

%% Make the psi matrix
psi = zeros(Nz*(m-1),(m-1)*(n+1));
psi(:,1:n) = temp*Bdw;
% Add D
for k = 1:Nz:Nz*(m-1)
    psi(k:(k+Nz-1),1:Nopt) = Dw +psi(k+(0:(Nz-1)),1:Nopt);
end

% Copy horizontally
for k = 2:m-1
    psi((k-1)*Nz+1:end,(k-1)*Nopt+(1:Nopt)) = psi(1:(end-(k-1)*Nz),1:Nopt);
end

% Copy first cols
psi = [psi(:,1:Nopt)+temp3*Cn2w*Bd psi];

% Add slack variables:
psi(Nz:Nz:end,2*Nopt:Nopt:end) = eye(m-1);




end

