function plotting(out,figurenumber,plotThrust,plotStates,plotExtra,disconnectGenset3Time,samplingstime,T)
bus = out.get('bus');
genset = out.get('genset');
power = out.get('power');
repower = out.get('repower');
tout = out.get('tout');
u = out.get('u');
vf = out.get('vf');
w0 = out.get('w0');
xTurbo = out.get('xTurbo');

saveThrust = 0;
saveStates = 0;
%id = 'noMPC';

numberOfPlots = 3;
figurenumber = (figurenumber-1)*numberOfPlots;


%% Fuel rates
if(plotThrust)
h=figure(figurenumber+1);
set(h,'PaperPosition', [0.125 1.25 12 8.0])
subplot(3,4,1)
plot(vf.time,vf.signals.values(:,1))
title('vf')
subplot(3,4,5)
plot(vf.time,vf.signals.values(:,2))
subplot(3,4,9)
plot(vf.time,vf.signals.values(:,3))

subplot(3,4,2)
plot(repower.time,repower.signals.values(:,1))
title('q')
subplot(3,4,6)
plot(repower.time,repower.signals.values(:,2))
subplot(3,4,10)
plot(repower.time,repower.signals.values(:,3))

subplot(3,4,3)
plot(u.time,u.signals.values(:,1))
title('u')
subplot(3,4,7)
plot(u.time,u.signals.values(:,2))
subplot(3,4,11)
plot(u.time,u.signals.values(:,3))

subplot(3,4,4)
plot(power.time,power.signals.values(:,1))
title('p')
subplot(3,4,8)
plot(power.time,power.signals.values(:,2))
subplot(3,4,12)
plot(power.time,power.signals.values(:,3))
if (saveThrust)
    saveas(h,sprintf('plots/thrust%s.eps',id),'psc2')
end
end

%% El-state
if(plotStates)
h=figure(figurenumber+2);
set(h,'PaperPosition', [0.125 1.25 12 8.0])
subplot(3,2,1)
plot(power.time,power.signals.values(:,1),...
    power.time,power.signals.values(:,2),...
    power.time,power.signals.values(:,3))
legend('p1','p2','p3')
xlabel('time');
ylabel('Active power sharing [p.u.]')

subplot(3,2,2)
plot(bus.time,bus.signals.values(:,4),'r--');
xlabel('time');
ylabel('Bus voltage [p.u.]')

subplot(3,2,3)
plot(genset.time,genset.signals.values(:,2),...
    genset.time,genset.signals.values(:,2+4),...
    genset.time,genset.signals.values(:,2+8))
legend('omega1','omega2','omega3')
xlabel('time');
ylabel('Frequency [p.u.]')




%% find time for disconnect:
disconnectI = length(genset.time);
for i=1:length(genset.time)
   if (genset.time(i)>disconnectGenset3Time)
       disconnectI = i;
       break
   end
end

subplot(3,2,5)
angle1 = anglemap(genset.signals.values(:,1)-bus.signals.values(:,3))*180/pi;
angle2 = anglemap(genset.signals.values(:,5)-bus.signals.values(:,3))*180/pi;
angle3 = anglemap(genset.signals.values(:,9)-bus.signals.values(:,3))*180/pi;
plot(genset.time,angle1,genset.time,angle2,genset.time(1:disconnectI),angle3(1:disconnectI))
legend('generator 1','generator 2','generator 3')
ylabel('Load angle [deg]')
xlabel('time');
ylim([20 90]);
loadangle = [angle1 angle2 angle3];

subplot(3,2,6)
plot(u.time,u.signals.values(:,1),...
    u.time,u.signals.values(:,2)...
    ,u.time,u.signals.values(:,3));
legend('generator 1','generator 2','generator 3')
ylabel('Fuel rack position [p.u.]')
xlabel('time');

subplot(3,2,4)
plot(T(1):samplingstime:T(2),w0,'.')
ylabel('No load frequency [p.u.]')
legend('generator 1','generator 2','generator 3')

if (saveStates)
    saveas(h,sprintf('plots/states%s.eps',id),'psc2')
end

if(plotExtra)
    h= figure(figurenumber+3);
    subplot(3,2,1)
    plot(xTurbo.time,xTurbo.signals.values(:,1));
    ylabel('Air-to-fuel ratio')
    xlabel('time [s]')
    ylim([0 60])
    
    subplot(3,2,2)
    plot(xTurbo.time,xTurbo.signals.values(:,2));
    ylabel('Turbo speed [pu]')
    xlabel('time [s]')
    
    subplot(3,2,3)
    plot(xTurbo.time,xTurbo.signals.values(:,3));
    ylabel('Air-to-fuel ratio')
    xlabel('time [s]')
    ylim([0 60])
    
    subplot(3,2,4)
    plot(xTurbo.time,xTurbo.signals.values(:,4));
    ylabel('Turbo speed [pu]')
    xlabel('time [s]')
    
    subplot(3,2,5)
    plot(xTurbo.time,xTurbo.signals.values(:,5));
    ylabel('Air-to-fuel ratio')
    xlabel('time [s]')
    ylim([0 60])
    
    subplot(3,2,6)
    plot(xTurbo.time,xTurbo.signals.values(:,6));
    ylabel('Turbo speed [pu]')
    xlabel('time [s]')
end
    
end

