clear all;
%% MAIN file, used for running of all simulation cases


%% Starts matlab workers for faster compilation
numWorkers   = matlabpool('size');
isPoolOpen   = (numWorkers > 0);
if(~isPoolOpen)
    matlabpool(3);
end

%% Simulates all cases
for casenr = 1:27
    fprintf('###################### Case %d ########################\n',casenr)
    %% Parameters for process plant
    init;
    
    %% Get case specific parameters
    cases;
    
    mdl = 'powerplant';
    load_system(mdl);
    
    %% Make log file
    debuggingfile = fopen(sprintf('%s\\results\\%s.txt',pwd,filename),'w');
    
    %% Simulate
    out=sim(mdl,T);
    fclose(debuggingfile);
        
    plotThrust = 0;
    plotStates = 1;
    plotExtra =1;
    plotting(out,1,plotThrust,plotStates,plotExtra,disconnectGenset3Time,samplingsTime,T);
    y = out;
    save(sprintf('results/%s.mat',filename));
    saveSelected(out,filename,Sb);
end
